freeslot("MT_WINDBALL","MT_DIGSPOT","MT_CYAURA","MT_SONICSPRING")

local byebye = { --Sonic spring
	[0] = FF_FULLBRIGHT,
	[1] = FF_TRANS90,
	[2] = FF_TRANS80,
	[3] = FF_TRANS70,
	[4] = FF_TRANS60,
	[5] = FF_TRANS50,
	[6] = FF_TRANS40,
	[7] = FF_TRANS30,
	[8] = FF_TRANS20,
	[9] = FF_TRANS10
}
rawset(_G, "IForgorWhatThisDoes", 	function(l)		end)
rawset(_G, "RockThinker", 			function(mo)	end)

local N_ThinkerFunctions = { --Kinda messy but... OPTIMIZED!
    [MT_SONICSPRING] = function(mo)
		if mo.addroll
			mo.rollangle = $+FixedAngle(abs(mo.momz))
		end
		if mo.fuse < 10
			local bop = byebye[mo.fuse]
			mo.frame = $|bop
		end
		
		mo.jumper = $ or 0
		if mo.jumper then mo.jumper = $-1 end
		if P_IsObjectOnGround(mo)
		and not mo.jumped
			mo.jumped = true
			mo.addroll = -$*2
			mo.jumper = 5
			P_SetObjectMomZ(mo, 5*FRACUNIT)
			if mo.fuse > 15
				mo.fuse = 15
			end
		end
		
		if (mo.eflags & MFE_JUSTHITFLOOR)
		and mo.jumped and not mo.jumper
			mo.addroll = 0
			mo.rollangle = 0
			for i = 1, 12
				local fa = (((360/12)*i)+P_RandomRange(-5, 5))*ANG1
				local ax = P_ReturnThrustX(nil, fa, mo.radius/2)
				local ay = P_ReturnThrustY(nil, fa, mo.radius/2)
				P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_DUST)
			end
		end end,
    [MT_WINDBALL] = function(mo)
		mo.youarenotgoinganywhere = $ or 0
		if mo.youarenotgoinganywhere then mo.youarenotgoinganywhere = $-1 end
		if (not (mo.target and mo.target.valid))
		or (mo.target and mo.target.valid and not mo.target.player)
			mo.target = mo.tracer
		end
		mo.interacted = $ or 0
		if mo.interacted then mo.interacted = $-1 end
		local tr = P_SpawnGhostMobj(mo)
		tr.destscale = FRACUNIT/3
		tr.fuse = 7
		if mo.charged
			local am = 8
			for i = 0, am
				local fang = (360/am)*i*ANG1
				local fa = (leveltime%360)*ANG2+fang
				local rad = mo.radius*2
				local ax = P_ReturnThrustX(nil, fa, rad)
				local ay = P_ReturnThrustY(nil, fa, rad)
				local ef = P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_THOK)
				ef.state = S_DUSTLAYER4
				ef.fuse = 2
				ef.momx = mo.momx
				ef.momy = mo.momy
				ef.momz = mo.momz
				ef.angle = R_PointToAngle2(ef.x, ef.y, mo.x, mo.y)+ANGLE_90
				ef.spriteyscale = FRACUNIT/3*2
				ef.spritexscale = FRACUNIT/3*2
				ef.spriteyoffset = -10*FRACUNIT
			end
		end
		if P_IsObjectOnGround(mo)
		and not mo.starttimer
			mo.starttimer = true
			mo.expt = mo.info.reactiontime
		end
		mo.expt = $ or 0
		if mo.expt
			if mo.starttimer
				mo.expt = $ - 1
				mo.doexplosion = true
			end
		elseif mo.doexplosion
			mo.doexplosion = false
			if mo.charged
				TN_ExplodeBall(mo)
			else
				TN_RemoveBall(mo)
			end
		end end,
    [MT_DEMONFIRE] = function(mo) if mo.ghostmis KnuxPunchThink(mo) end end,
	[MT_PARTICLE] = function(mo) if mo.jumppad WindThinker(mo) end end,
	[MT_FALLINGROCK] = function(mo) if mo.knuxrock RockThinker(mo) end end,
	[MT_DIGSPOT] = function(mo)
		if mo.state == S_DIGSPOT_SHOW
		or mo.state == S_DIGSPOT
			if devparm 
			and ((mo.state == S_DIGSPOT) or (mo.state == S_DIGSPOT_SHOW))
				mo.state = S_DIGSPOT_SHOW
				mo.tics = 3
			end
			if mo.state != S_DIGSPOT
				if mo.wasdug
					mo.frame = B
				else
					mo.frame = A
				end
			end
		end end,
	[MT_THOK] = function(mo) 
		if mo.ghosten ChargeThinker(mo) end 
		if mo.bruhlamp IForgorWhatThisDoes(mo) end
		if mo.breakwalls --Windball FOF breaker
		and mo.subsector and mo.subsector.sector
			CheckAndCrumble(mo, mo.subsector.sector)
		end 
		if mo.switchteam --Team switching trail
			local f = P_SpawnMobjFromMobj(mo,0,0,0, MT_THOK)
			f.scale = mo.scale
			f.color = mo.color
			f.destscale = mo.scale/5
			
			if mo.target and mo.target.valid
				local t = mo.target
				
				local px = t.x-mo.x
				local py = t.y-mo.y
				local pz = (t.z+t.height/2)-(mo.z+mo.height/2)
				
				local fsped = 60*FRACUNIT
				local psped = P_AproxDistance(P_AproxDistance(t.momx,t.momy),t.momz)
				local pdist = P_AproxDistance(P_AproxDistance(px,py),pz)
				if psped+(pdist/7) > fsped
					fsped = psped+(pdist/7)+10*FRACUNIT
				end
				P_FlyTo(mo, t.x, t.y, t.z, fsped, false)
				
				
				if pdist <= 74*FRACUNIT
					P_KillMobj(mo)
				end
			end
		end end
}

addHook("ThinkFrame", function()
    for i,k in pairs(N_GlobalThinkers)
        local mo = N_GlobalThinkers[i]
        if (not mo.valid
        or mo.health <= 0)
			if leveltime > 5
				table.remove(N_GlobalThinkers, i)
				continue
			end
        end
		if mo and mo.valid
		and not (mo.flags & MF_NOTHINK)
			if (mo.shouldgoback and MonitorRespawn(mo)) MonitorRespawn(mo) end
			if N_ThinkerFunctions[mo.type]
			and N_ThinkerFunctions[mo.type](mo)
				N_ThinkerFunctions[mo.type](mo)
			end
		end
    end
end)

addHook("ShouldDamage", function(mo,mobj) --A fix for Tails`s And Knux`s projectiles.
	if mo and mo.valid
	and mo.type == MT_PLAYER
		if mobj and mobj.valid
		and (mobj.type == MT_WINDBALL
		or mobj.type == MT_FALLINGROCK
		or mobj.type == MT_DEMONFIRE)
		and mobj.target and mobj.target.valid --I dont care if it has a tracer.
			if mobj.target.player and mobj.target.player.valid
			and mo.player and mo.player.valid
				local p2 = mo.player
				local p = mobj.target.player
				if SameTeam(p,p2) != 2
					return false
				end
			end
		end
	end
end)