freeslot("MT_SONICSPRING")

mobjinfo[MT_SONICSPRING] = {
	doomednum = -1,
	spawnstate = S_REDSPRING,
	spawnhealth = 1000,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 15*FRACUNIT,
	flags = MF_SPRING,
	raisestate = S_REDSPRING2
}

local function SpawnSnewSpring(player)
	local s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SONICSPRING)
	s.momx = -player.mo.momx/3
	s.momy = -player.mo.momy/3
	s.momz = -player.mo.momz/3
	s.rollspring = ANG1-(ANG2*P_RandomRange(0, 1))
	if s.rollspring < 0
		s.addroll = -ANG1/5
	else
		s.addroll = ANG1/5
	end
	s.fuse = TICRATE/2*3
	if s and s.valid
		player.usespring = true
	end
	AddToTable(s,N_GlobalThinkers)
end

addHook("AbilitySpecial", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		if not player.usespring
		and not (player.pflags & PF_THOKKED)
		and CanUse(player, true)
		and not player.wallCling
		and not player.secondjump
		and not player.bashstate
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			SpawnSnewSpring(player)
		end
	end
end)
freeslot("SPR_PTEN", "S_EPIC_UP", "S_EPIC_DOWN")
states[S_EPIC_UP] = {SPR_PTEN, A|FF_FULLDARK|FF_PAPERSPRITE, TICRATE, nil, 0, 0, S_NULL}
states[S_EPIC_DOWN] = {SPR_PTEN, B|FF_FULLDARK|FF_PAPERSPRITE, TICRATE, nil, 0, 0, S_NULL}
addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		if P_IsObjectOnGround(player.mo)
		or player.powers[pw_carry]
		or player.notrig
			player.usespring = false
		end
		if player.cmd.buttons & BT_SPIN
		and not P_IsObjectOnGround(player.mo)
		and not player.superwait
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			if not player.recurl
			and CanUse(player)
			and not player.bashstate
			and not player.nearWall
			and not player.secondjump
			and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			and (not (player.pflags & PF_JUMPED)
			or (player.pflags & PF_SPINNING) or (player.pflags & PF_NOJUMPDAMAGE))
				if (player.pflags & PF_SPINNING)
					S_StartSound(player.mo, sfx_s3k42)
				else
					S_StartSound(player.mo, sfx_spin)
				end
				player.pflags = $|PF_JUMPED
				player.pflags = $&~(PF_SPINNING|PF_NOJUMPDAMAGE)
				player.mo.state = S_PLAY_JUMP
				player.crollcd = 5
			end
			player.recurl = true
		else
			player.recurl = false
		end
	end
end)