//I hate wall checks so much...

freeslot("SPR2_RUNR","SPR2_RUNL","S_PLAY_WALLRUN_R","S_PLAY_WALLRUN_L")
states[S_PLAY_WALLRUN_R] = {SPR_PLAY,SPR2_RUNR,2,nil,0,0,S_PLAY_WALLRUN_R}
states[S_PLAY_WALLRUN_L] = {SPR_PLAY,SPR2_RUNL,2,nil,0,0,S_PLAY_WALLRUN_L}

rawset(_G, "N_FOFCheck",function(player, angle)

	local platx, platy
	local glidesector
	local floorz, ceilingz
	local mo = player.mo
	local rover

	platx = P_ReturnThrustX(mo, angle, mo.radius + FixedMul(8*FRACUNIT, mo.scale))
	platy = P_ReturnThrustY(mo, angle, mo.radius + FixedMul(8*FRACUNIT, mo.scale))

	glidesector = R_PointInSubsector(mo.x + platx, mo.y + platy).sector
	
	if glidesector
		floorz = glidesector.floorheight
		ceilingz = glidesector.ceilingheight

		if (glidesector ~= mo.subsector.sector)
		
			local floorclimb = false
			local topheight, bottomheight

			for rover in glidesector.ffloors()
			
				if (not (rover.flags & FF_EXISTS) or not (rover.flags & FF_BLOCKPLAYER))
					continue
				end

				topheight = rover.topheight
				bottomheight = rover.bottomheight

				floorclimb = true

				if (mo.eflags & MFE_VERTICALFLIP)
				
					if ((topheight < mo.z + mo.height) and ((mo.z + mo.height + mo.momz) < topheight))
						floorclimb = true
					end
					if (topheight < mo.z) // Waaaay below the ledge.
						floorclimb = false
					end
					if (bottomheight > mo.z + mo.height - FixedMul(16*FRACUNIT,mo.scale))
						floorclimb = false
					end
				else
				
					if ((bottomheight > mo.z) and ((mo.z - mo.momz) > bottomheight))
						floorclimb = true
					end
					if (bottomheight > mo.z + mo.height) // Waaaay below the ledge.
						floorclimb = false
					end
					if (topheight < mo.z + FixedMul(16*FRACUNIT,mo.scale))
						floorclimb = false
					end
				end

				if (floorclimb)
					break
				end
			end

			if (not floorclimb)
				return false
			end

			return true
		end
	else
		return true
	end

	return false
end)

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo and mo.valid
		if mo.player and mo.player.valid
		and mo.skin == "sonicnew"
			local player = mo.player
			if not P_IsObjectOnGround(mo)
			and not player.cantWall
				if line
					player.wallJumped = 0
					local whichside = P_PointOnLineSide(mo.x,mo.y,line)
					local angle = R_PointToAngle2(line.v1.x,line.v1.y,line.v2.x,line.v2.y)
					angle = $+(ANGLE_90*(whichside and -1 or 1))
					
					player.wallLastAng = angle
					local lineside = line.sidenum[P_PointOnLineSide(mo.x, mo.y, line)]
					local side = sides[lineside]
					local pside = side
					local iside = side
					local psec
					if line.frontside == side
						pside = line.backside
						iside = line.frontside
						psec = line.backsector
					else
						pside = line.frontside
						iside = line.backside
						psec = line.frontsector
					end
					if line.special == 41
						player.cantClimb = true
					end
					if psec
						if mo.subsector and mo.subsector.sector
						and mo.subsector.sector == psec
							player.cantClimb = true
						end
						if psec.ceilingpic == "F_SKY1"
						and (mo.z+(mo.height/3*2)) > psec.ceilingheight
							player.cantClimb = true
						end
						if psec.floorpic == "F_SKY1"
						and (mo.z+(mo.height/3)) < psec.floorheight
							player.cantClimb = true
						end
						
						local floorz = psec.floorheight
						local ceilingz = psec.ceilingheight
						local floorclimb = false
						if (mo.eflags & MFE_VERTICALFLIP)
		
							if ((floorz <= mo.z + mo.height)
								and ((mo.z + mo.height - mo.momz) <= floorz))
								floorclimb = true
							end

							if ((floorz > mo.z)
								and psec.floorpic == "F_SKY1")
								return false
							end

							if ((mo.z + mo.height - FixedMul(16*FRACUNIT,mo.scale) > ceilingz)
								or (mo.z + mo.height <= floorz))
								floorclimb = true
							end
						else
						
							if ((ceilingz >= mo.z)
								and ((mo.z - mo.momz) >= ceilingz))
								floorclimb = true
							end

							if ((ceilingz < mo.z+mo.height)
								and psec.ceilingpic == "F_SKY1")
								return false
							end

							if ((mo.z + FixedMul(16*FRACUNIT,mo.scale) < floorz)
								or (mo.z >= ceilingz))
								floorclimb = true
							end
						end
						if (not floorclimb)
							player.cantClimb = true
						end
						
						
						if iside
							if not iside.toptexture --Check if the side you`re on has texture
							and (mo.z+(mo.height/3*2)) > psec.ceilingheight
								if pside and pside.toptexture --If it doesnt check the other side
								and (mo.z+(mo.height/3*2)) > psec.ceilingheight
									player.cantClimb = false --If it does, then can climb
								else
									player.cantClimb = true --Doesnt? Cant climb.
								end
							end
							if not iside.midtexture --Repeat.
							and (mo.z+(mo.height/2)) < psec.ceilingheight
							and (mo.z+(mo.height/2)) > psec.floorheight
								if pside and pside.midtexture
								and (mo.z+(mo.height/2)) < psec.ceilingheight
								and (mo.z+(mo.height/2)) > psec.floorheight
									player.cantClimb = false
								else
									player.cantClimb = true
								end
							end
							if not iside.bottomtexture
							and (mo.z+(mo.height/3)) < psec.floorheight
								if pside and pside.bottomtexture
								and (mo.z+(mo.height/3)) < psec.floorheight
									player.cantClimb = false
								else
									player.cantClimb = true
								end
							end
						end
					else
						player.cantClimb = false
					end
					if iside
						if not iside.toptexture
						and not iside.bottomtexture
						and not iside.midtexture
							player.cantClimb = true
						end
					end
					if N_FOFCheck(player,player.wallLastAng+ANGLE_180)
					or N_FOFCheck(player,player.wallLastAng)
						player.cantClimb = false
					end
					player.wallAng = player.wallLastAng+ANGLE_180
				end
				if mobj and mobj.valid
				and mobj != mo
					player.wallAng = R_PointToAngle2(mobj.x,mobj.y,mo.x,mo.y)
				end
				
					if not mo.player.cantClimb
					and not P_IsObjectOnGround(mo)
					and not mo.player.powers[pw_carry]
					and not player.celcling
						if (((mo.momz*P_MobjFlip(mo) <= 6*P_GetMobjGravity(mo)) or (mo.player.cmd.buttons & BT_JUMP) or player.bashhome))
							mo.startwall = true
							local runsped = R_PointToAngle2(0,0,mo.momx,mo.momy)
							local yesang = ANGLE_45
							if player.speed > player.runspeed/2
							and player.wallAng
							and ((abs((player.wallAng+ANGLE_90)-runsped) <= yesang)
							or (abs((player.wallAng-ANGLE_90)-runsped) <= yesang))
								local sider = -1
								mo.wallrunang = player.wallAng+ANGLE_90
								if (abs((player.wallAng-ANGLE_90)-runsped) <= yesang)
									sider = 1
									mo.wallrunang = player.wallAng-ANGLE_90
								end
								if sider
									if sider == 1
										mo.wallrunside = SPR2_RUNR
									else
										mo.wallrunside = SPR2_RUNL
									end
								end
							else
								mo.wallrunside = SPR2_STUN
							end
						end
						if mo.startwall
							if not player.wallCling
								if mo.momz*P_MobjFlip(mo) < 0
									mo.momz = $/2
								end
								S_StartSound(mo, sfx_kc50)
								mo.state = S_PLAY_FALL
								player.drawangle = player.wallAng+ANGLE_180
								if not mo.player.powers[pw_super]
									mo.frame = A
									mo.sprite2 = SPR2_STUN
									if mo.wallrunside
										mo.sprite2 = mo.wallrunside
									end
									mo.tics = 15
								end
								
								player.pflags = $&~(PF_SPINNING|PF_THOKKED)
								player.pflags = $|PF_JUMPED
								player.usespring = false
							end
							if player.powers[pw_super]
								if mo.momz*P_MobjFlip(mo) < (P_GetMobjGravity(mo)*P_MobjFlip(mo))*4
									mo.momz = (P_GetMobjGravity(mo)*P_MobjFlip(mo))*4
								end
								mo.state = S_PLAY_FALL
								mo.tics = 15
								player.drawangle = player.wallAng
								player.pflags = $&~(PF_SPINNING|PF_THOKKED)
								player.pflags = $|PF_JUMPED
								player.usespring = false
							end
							if mo.momz*P_MobjFlip(mo) > P_GetMobjGravity(mo)
							and mo.state == S_PLAY_FALL
							and mo.sprite2 == SPR2_STUN
								mo.state = S_PLAY_FALL
								player.drawangle = player.wallAng+ANGLE_180
								if not mo.player.powers[pw_super]
									mo.frame = A
									mo.sprite2 = SPR2_STUN
									if mo.wallrunside
										mo.sprite2 = mo.wallrunside
									end
									mo.tics = 15
								end
								player.pflags = $&~(PF_SPINNING|PF_THOKKED)
								player.pflags = $|PF_JUMPED
								player.usespring = false
							end
							player.wallCling = 15
						end	
					end
					if not player.cantClimb
					and not player.specildeal
						player.nearWall = 5
					end
			end
		end
	end
end, MT_PLAYER)

local function JumpWall(player)
	player.exhaustjump = $-1
	player.cantWall = 15
	player.wallCling = 0
	player.mo.state = S_PLAY_JUMP
	player.pflags = $|PF_JUMPED
	player.pflags = $ & ~(PF_THOKKED|PF_SPINNING|PF_NOJUMPDAMAGE)
	player.usespring = false
	player.mo.startwall = false
	player.mo.startwallrun = false
	player.nobash = 0
	player.drawangle = player.wallAng
	S_StartSound(player.mo, sfx_jump)
	local elmz = (player.mo.momz*P_MobjFlip(player.mo))
	local mzdown = 0
	local slowmomz = 1
	if elmz > 0
		mzdown = 0
	else
		mzdown = abs(elmz)
	end
	if elmz <= FRACUNIT
		slowmomz = 1
	else
		slowmomz = elmz/FRACUNIT
	end
	local nine = 11
	local ten = 10
	if slowmomz > nine + ten //U Stupid, Whats 9+10
		slowmomz = 21 //21?
	end
	if slowmomz < 1
		slowmomz = 1
	end
	P_Thrust(player.mo, player.drawangle, FixedMul(player.mo.scale,26*FRACUNIT))
	P_SetObjectMomZ(player.mo, 10*FRACUNIT+mzdown, true)
	if (player.dashsped and player.dashsped >= 4*TICRATE)
	or (player.mo.sprite2 == SPR2_RUNR or player.mo.sprite2 == SPR2_RUNL) 
		if (player.cmd.forwardmove or player.cmd.sidemove)
			P_Thrust(player.mo, player.ctrlAng, FixedMul(player.mo.scale,5*FRACUNIT))
		end
	end
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		player.wallAng = $ or 0
		player.nearWall = $ or 0
		player.wallspin = $ or 0
		player.ctrlAng = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
		if player.nearWall
			player.nearWall = $ - 1
		else
			player.mo.startwall = false
			player.mo.startwallrun = false
		end
		if P_IsObjectOnGround(player.mo)
			player.exhaustjump = 3
		elseif CBW_Battle
			if not player.exhaustjump
				player.cantWall = 5
			elseif player.exhaustjump == 1 and not(leveltime&7)
				local g = P_SpawnGhostMobj(player.mo)
				g.fuse = 7
				g.color = SKINCOLOR_BROWN
				g.colorized = true
				S_StartSound(player.mo,sfx_s3kbb,player)
			end
		end
		if player.cmd.buttons & BT_JUMP
			if not player.lewalljumped
			and not player.cantClimb
			and not player.cantWall
			and player.wallCling
			and CanUse(player)
			and ((player.mo.state == S_PLAY_FALL
			and (player.mo.sprite2 == SPR2_STUN 
				or player.mo.sprite2 == SPR2_RUNR
				or player.mo.sprite2 == SPR2_RUNL))
			
			or player.powers[pw_super])
				JumpWall(player)
			end
			player.lewalljumped = true
		else
			player.lewalljumped = false
		end
		if player.wallCling
			player.wallCling = $ - 1
			if player.mo.state == S_PLAY_FALL
			and player.wallAng
				if player.mo.sprite2 == SPR2_STUN
					player.drawangle = player.wallAng+ANGLE_180
				elseif (player.mo.sprite2 == SPR2_RUNR or player.mo.sprite2 == SPR2_RUNL) 
				and player.mo.wallrunang
					player.drawangle = player.mo.wallrunang
				end
			end
			if player.cantClimb
			and player.mo.state == S_PLAY_FALL
			and player.mo.tics > 1
				if ((player.mo.sprite2 == SPR2_RUNR or player.mo.sprite2 == SPR2_RUNL) 
				and player.mo.wallrunang) or player.mo.sprite2 == SPR2_STUN
					player.mo.tics = 1
				end
			end
		else
			if player.cantClimb
				player.cantClimb = false
			end
		end
		if player.cantWall
			player.cantWall = $ - 1
		end
	end
end)