addHook("PlayerSpawn", function(player)
	if not N_ReturnPlayer(player) return end
	
	player.startsucc = 0
	player.dodasuck = false
	player.nodrop = 0
	player.droprangs = false
	player.stopsound = false
	player.applycd = 0
	player.ballcd = 0
	player.balluses = 0
	player.superjump = 0
	player.wjumpcd = 0
end)

addHook("ShieldSpecial", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		return true
	end
end)

addHook("PlayerThink", function(player) --Execute Frontiers DMG last.
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		player.stunpainrings = $ or 0
		if player.stunpainrings then player.stunpainrings = $-1; player.pflags = $|PF_FULLSTASIS; player.mo.state = S_PLAY_PAIN; player.powers[pw_flashing] = flashingtics end
		player.nodrop = $ or 0
		if player.nodrop then player.nodrop = $-1 end
		if player.droprangs --Frontiers DMG system.
		and not player.nodrop
		and P_IsObjectOnGround(player.mo)
			local microp = {x = player.mo.momx, y = player.mo.momy}
			player.mo.momx = -$
			player.mo.momy = -$
			P_PlayerRingBurst(player)
			P_PlayRinglossSound(player.mo)
			player.rings = 0
			player.mo.momx = microp.x
			player.mo.momy = microp.y
			player.droprangs = false
			player.stunpainrings = flashingtics/3
			player.powers[pw_flashing] = flashingtics-1
			player.mo.spriteyscale = FRACUNIT/2
			player.mo.spritexscale = FRACUNIT*2
		end
		if player.mo.nofrontiers then player.mo.nofrontiers = $-1 end
	end
end)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype) --When getting hit, dont drop rings.
	if mo and mo.valid
	and mo.player and mo.player.valid
	and not (dmgtype & DMG_DEATHMASK)
		if mobj and mobj.valid
			if mobj.gotosucc and mobj.gotosucc.valid
			and mobj.gotosucc == mo
				mo.nofrontiers = 5
				return true
			end
			if mobj.carry and mobj.carry.valid
			and mobj.carry == mo
				mo.nofrontiers = 5
				return true
			end
		end
		if mo.player.rings
			local player = mo.player
			if player and player.valid and player.playerstate == PST_LIVE and not player.spectator
			and player.powers[pw_carry] != CR_NIGHTSMODE and mo.skin == "recenttails"
				if not player.powers[pw_shield]
				and not player.mo.nofrontiers
					player.losstime = $+TICRATE*5
					player.powers[pw_shield] = SH_PITY
					player.nodrop = 15
					player.droprangs = true
				end
			end
		end
	end
end, MT_PLAYER)